#!/usr/bin/env python
# -*- mode: python; coding: koi8-r -*-


import string, os

import gtk, pango
from gtk import TRUE, FALSE

from pybookreader.bookmarkswindow import *
from pybookreader.bookmarks import *
from pybookreader.utils import *
from pybookreader.scrolledtext import *
from pybookreader.bookbuffer import *
from pybookreader.propswindow import PropsWindow

##----------------------------------------------------------------------
##----------------------------------------------------------------------

class PyBookReader(gtk.Window):


    def __init__(self):
        gtk.Window.__init__(self)

        # widgets
        #self.text_widget = None
        #self.text_buffer = None
        #self.scale = None
        #self.pause_toggle = None
        #self.percent_status = None
        self.bookmarks_manager = None
        #self.bookmarks_menu = None
        #self.bookmarks_submenu = None
        #self.books_menu = None
        #self.books_submenu = None

        self.percent_font = 'Sans Bold 16'

        self.main_properties = {
            # <name><type><value>
            'width'                           : ['int',   600      ],
            'height'                          : ['int',   400      ],
            'bookmarks_manager_width'         : ['int',   600      ],
            'bookmarks_manager_height'        : ['int',   400      ],
            'bookmarks_manager_paned_position': ['int',   200      ],
            'hide_statusbar'                  : ['int',   0        ],
            'font'                            : ['str',   'Normal' ],
            'fg_color'                        : ['str',   '#000000'],
            'bg_color'                        : ['str',   '#ffffff'],
            'bookmark_tag_color'              : ['str',   '#ff0000'],
            'speed'                           : ['float', 20.0     ],
            'filename'                        : ['str',   None     ],
            'file_select_path'                : ['str',   OpenFileDialog.file_select_path]
            }


        # block charset menu (fix it?)
        self.block_change_charset = 0

        menu_hide_status_bar = 0

        self.bookmarks = None
        self.current_book = None

##----------------------------------------------------------------------

        self.bookmarks = Bookmarks()

        self.set_title(program_name)

        menu_items = [
            ('/_File', None, None, 0, '<Branch>' ),
            #('/_File/tearoff1', None, self.ifactory_cb, 0, '<Tearoff>'),
            ('/_File/_Open...', '<control>O', self.menu_open_cb, 0, ''),
            ('/_File/sep1', None, None, 0, '<Separator>'),
            ('/_File/_Quit', '<control>Q',
             lambda s, w: self.destroy(), 0, ''),
            ('/_File/Quit without saving', None,
             lambda s, w: gtk.main_quit(), 0, ''),

            ('/_Go/Go to book_mark',
             None, None, 0, '<Branch>'),
            ('/_Go/Go to book',
             None, None, 0, '<Branch>'),
            ('/_Go/Go to _position',
             '<control>G', self.menu_goto_position_cb, 0, ''),
            ('/_Go/Go to _begin', None, lambda s, w:
             self.text_widget.set_position(0.0), 0, ''),
            ('/_Go/Go to _end', None, lambda s, w:
             self.text_widget.set_position(1.0), 0, ''),
            ('/_Go/sep1', None, None, 0, '<Separator>'),
            ('/_Go/_Search',
             '<control>S', self.menu_search_cb, 0, ''),
            ('/_Go/Search again _forward',
             '<control>F', self.menu_search_again_forward_cb, 0, ''),
            ('/_Go/Search again back_ward',
             None, self.menu_search_again_backward_cb, 0, ''),
            ('/_Go/Search _regexp',
             None, self.menu_regexp_search_cb, 0, ''),
            ('/_Go/Search re_gexp again',
             None, self.menu_regexp_search_again_cb, 0, ''),

            ('/_Bookmarks', None, None, 0, '<Branch>' ),
            ('/_Bookmarks/Book_marks manager ...',
             '<control>M', self.menu_bookmarks_manager_cb, 0, ''),
            ('/_Bookmarks/_Set bookmark',
             '<control>B', self.menu_set_bookmark_cb, 0, ''),
            ('/_Bookmarks/Se_t bookmark with ...',
             '<control>D', self.menu_set_bookmark_with_cb, 0, ''),
            ('/_Bookmarks/Use regexp for creation bookmarks ...',
             None, self.menu_regexp_bookmarks_cb, 0, ''),

            ('/_Preferences', None, None, 0, '<Branch>'),
            ('/_Preferences/Fon_t...', None, self.menu_font_cb, 0, ''),
            ('/_Preferences/_Foreground color...',
             None, self.menu_color_cb, 0, ''),
            ('/_Preferences/_Background color...',
             None, self.menu_color_cb, 1, ''),
            ('/_Preferences/Bookmarks color...',
             None, self.menu_color_cb, 2, ''),
            #('/_Preferences/_Debug', None, self.menu_debug_cb, 2, ''),
            ('/_Preferences/sep1', None, None, 0, '<Separator>'),
            #('/_Preferences/_Full screen', None,
            # self.menu_full_screen_cb, 0, '<ToggleItem>'),
            ('/_Preferences/_Hide status bar', None,
             self.menu_hide_status_bar_cb, 0, '<ToggleItem>'),
            ('/_Preferences/sep1', None, None, 0, '<Separator>'),
            ('/_Preferences/_Properties...',
             None, self.menu_props_cb, 0, ''),

            ('/_Speed', None,  None, 0, '<Branch>'),
            ('/_Speed/_Fast  \t+',  None, self.menu_speed_cb, 0, ''),
            ('/_Speed/_Slow  \t-',  None, self.menu_speed_cb, 1, ''),
            ('/_Speed/_Pause \tInsert', None, self.menu_speed_cb, 2, ''),

            ('/_Charset', None, None, 0, '<Branch>'),
            ]

        # charsets menu
        path = '/Charset/' + charsets_list[0]
        menu_items.append((path, None, self.menu_charset_cb, 0, '<RadioItem>'))
        for i in range (1, len(charsets_list)):
            menu_items.append(('/Charset/' + charsets_list[i],
                               None, self.menu_charset_cb, i, path))

        accelgroup = gtk.AccelGroup()
        self.add_accel_group(accelgroup)
        self.accelgroup = accelgroup

        self.connect('destroy', self.destroy_cb)
        self.connect('size_allocate', self.size_allocate_cb)

        # top level vbox
        vbox = gtk.VBox()
        self.add(vbox)

        # menu
        item_factory = gtk.ItemFactory(gtk.MenuBar, '<main>', accelgroup)
        item_factory.create_items(menu_items)
        self.item_factory = item_factory

        menubar = item_factory.get_widget('<main>')

        handle = gtk.HandleBox()
        handle.add(menubar)
        vbox.pack_start(handle, expand=FALSE)
        #vbox.pack_start(menubar, expand=FALSE)

        # bookmarks menu
        self.bookmarks_menu = item_factory.get_item('/Go/Go to bookmark')

        # books menu
        self.books_menu = item_factory.get_item('/Go/Go to book')

        # text widget
        self.text_widget = ScrolledText()
        vbox.pack_start(self.text_widget, expand=TRUE)

        # text buffer
        self.text_buffer = BookBuffer()
        self.text_widget.set_buffer(self.text_buffer)

        self.text_widget.vadjustment.connect('value_changed',
                                             self.position_changed_cb)

        self.text_widget.connect('pause-toggled', self.pause_toggled)
        self.text_widget.connect('speed-changed', self.speed_changed)
        self.text_widget.connect('unrealize', self.text_widget_unrealize)

        # search vars
        # TODO: to bookbuffer

        self.search_string = ''
        self.search_regexp = ''

        self.search_string_flag = 0
        self.search_regexp_flag = 0


        self.full_screen_flag = 0

        self.read_config()

        statusbar = self.create_statusbar()
        vbox.pack_end(statusbar, expand=FALSE)

        self.set_default_size(self.main_properties['width'][1],
                              self.main_properties['height'][1])

        self.show_all()
        if self.main_properties['hide_statusbar'][1] == 1:
            i = item_factory.get_item('/Preferences/Hide status bar')
            i.activate()


        filename = self.main_properties['filename'][1]
        if filename:
            try:
                self.insert_file(self.main_properties['filename'][1])
            except Exception, err:
                print 'ERROR:', err

##----------------------------------------------------------------------

    def menu_full_screen_cb(self, a, w):
        if self.full_screen_flag:
            self.unmaximize()
            self.hide()
            self.full_screen_flag = 0
            self.set_decorated(TRUE)
            self.show()
        else:
            self.hide()
            self.full_screen_flag = 1
            self.set_decorated(FALSE)
            self.show()
            self.maximize()

##----------------------------------------------------------------------

    def menu_hide_status_bar_cb(self, a, w):
        if self.statusbar.get_property('visible'):
            self.main_properties['hide_statusbar'][1] = 1
            self.statusbar.hide()
        else:
            self.main_properties['hide_statusbar'][1] = 0
            self.statusbar.show()

##----------------------------------------------------------------------

    def menu_regexp_search_cb(self, a, w):

        strng = entry_dialog(self, 'Search', 'Regexp: ', self.search_regexp)

        if strng:

            self.search_regexp = strng

            iter = self.text_buffer.search_regexp(strng)

            if iter:
                self.text_widget.scroll_to_iter(iter, 0.0)
                self.search_regexp_flag = 1
            else:
                info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_regexp_search_again_cb(self, a, w):

        if self.search_regexp_flag:
            iter = self.text_buffer.search_regexp_again()
            if iter:
                self.text_widget.scroll_to_iter(iter, 0.0)
            else:
                info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_cb(self, a, w):

        strng = entry_dialog(self, 'Search', 'Search: ', self.search_string)
        self.search_string = strng

        iter = self.text_buffer.search_string(strng)

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
            self.search_string_flag = 1
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_again_forward_cb(self, a, w):

        if not self.search_string_flag: return

        iter = self.text_buffer.search_string_again_forward()

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_again_backward_cb(self, a, w):

        if not self.search_string_flag: return

        iter = self.text_buffer.search_string_again_backward()

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_regexp_bookmarks_cb(self, a, w):

        strng = entry_dialog(self, 'Regexp', 'Regexp: ')

        if strng:

##             dialog = gtk.Dialog('Progress', self,
##                                 gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
##                                 (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
##             hbox = gtk.HBox()
##             dialog.vbox.pack_start(hbox, TRUE, TRUE, 0)
##             label = gtk.Label('Progress: ')
##             hbox.pack_start(label, expand=FALSE)
##             progress = gtk.ProgressBar()
##             hbox.pack_start(progress)
##             dialog.show_all()

            gtk.gdk.flush()

            self.text_buffer.regexp_bookmarks_init(strng)

            while 1:
                if not self.text_buffer.regexp_bookmarks_next():
                    break

##                 fract = float(self.text_buffer.line_index) \
##                        / len(self.text_buffer.text_lines)
##                 progress.set_fraction(fract)
##                 gtk.gdk.window_process_all_updates
##                 gtk.gdk.flush()

            numder_bookmarks = self.text_buffer.regexp_bookmarks_finally()
            info_dialog(self, 'Created %d bookmarks' % numder_bookmarks)
            if self.bookmarks_manager:
                self.bookmarks_manager.update_treeview()

            self.update_bookmarks_menu()

##             dialog.destroy()

##----------------------------------------------------------------------

    # DEBUG
    def menu_debug_cb(self, a, w):
        print "debug"

        #return

        #print self.bookmarks.books_list
        #print self.bookmarks.categories_list

        print '****** categories_list ******'
        for cat in self.bookmarks.categories_list:
            print string_encode(cat, 'utf-8', 'koi8-r')
            for b in self.bookmarks.categories_list[cat]:
                print '  ', b.filename
        print

        return

        bookmarks = self.bookmarks

        print '****** books_list ******'
        print

        for book in bookmarks.books_list:

            print 'filename =', book.filename
            print 'author =', string_encode(book.author, 'utf-8', 'koi8-r')
            print 'name =',  string_encode(book.name, 'utf-8', 'koi8-r')
            #print 'description =', string_encode(book.description,
            #                                     'utf-8', 'koi8-r')
            print 'current_position =', book.current_position
            print 'current_offset =', book.current_offset
            print 'encoding =', book.encoding
            print

            print '   *** marks_list ***'
            print

            for mark in book.marks_list:

                print '   namber =', mark.number
                print '   offset =', mark.offset
                print '   position =', mark.position
                #print '   description =', string_encode(mark.description,
                #                                        'utf-8', 'koi8-r')
                #print '   author =', string_encode(mark.author,
                #                                   'utf-8', 'koi8-r')
                #print '   name =', string_encode(mark.name,
                #                                 'utf-8', 'koi8-r')
                print



##----------------------------------------------------------------------
##----------------------------------------------------------------------

    def pause_toggled(self, w, a):
        self.pause_toggle.set_active(a)

##----------------------------------------------------------------------

    def speed_changed(self, w, a):
        adj = self.scale.get_adjustment()
        adj.set_value (a)

##----------------------------------------------------------------------

    def text_widget_unrealize(self, w):
        self.save_bookmark()

##----------------------------------------------------------------------
    def destroy_cb(self, w):
        self.hide()
        if self.bookmarks_manager:
            self.bookmarks_manager.hide()
            self.bookmarks_manager.destroy()
        try: # debug
            if self.make_config_dir():
                self.bookmarks.save_bookmarks()
                self.save_config()
        finally:
            gtk.main_quit()

##----------------------------------------------------------------------

    def size_allocate_cb(self, w, rect):

        if not self.full_screen_flag:
            self.main_properties['width'][1] = rect.width
            self.main_properties['height'][1] = rect.height

##----------------------------------------------------------------------

    def position_changed_cb(self, w):

        self.bookmark_value = self.text_widget.get_position()
        percent = int(self.bookmark_value*100)
        self.percent_status.set_text('%d%%' % percent)

##----------------------------------------------------------------------

    def speed_changed_cb(self, w):

        adj = self.scale.get_adjustment()
        self.text_widget.speed = adj.get_value()
        self.text_widget.speed_changed()

##----------------------------------------------------------------------
##-- signals from bookmarks manager ------------------------------------

    def bookmarks_manager_destroy_cb(self, w):
        self.main_properties['bookmarks_manager_width'][1] = w.width
        self.main_properties['bookmarks_manager_height'][1] = w.height
        self.main_properties['bookmarks_manager_paned_position'][1] \
             = w.paned.get_position()
        self.bookmarks_manager = None

##----------------------------------------------------------------------

    def bookmarks_manager_load_file_cb(self, w, filename):

        if self.main_properties['filename'][1] != filename:
            self.insert_file(filename)
        else:
            self.set_position()

##----------------------------------------------------------------------

    def bookmarks_manager_book_removed_cb(self, w, filename):

        if self.main_properties['filename'][1] == filename:
            book = self.bookmarks.get_any_book()
            if book:
                self.insert_file(book.filename)
            else:
                self.set_title(program_name)
                # clear buffer
                start, end = self.text_buffer.get_bounds()
                self.text_buffer.delete(start, end)

                self.main_properties['filename'][1] = None
                self.current_book = None

        self.update_books_menu()

##----------------------------------------------------------------------

    def bookmarks_manager_book_changed_cb(self, w, filename):
        if self.main_properties['filename'][1] == filename:
            self.insert_file(filename)

##----------------------------------------------------------------------

    def bookmarks_manager_bookmarks_changed_cb(self, w, filename):
        if self.main_properties['filename'][1] == filename:
            self.update_bookmarks_menu()
            self.text_buffer.update_highlight_bookmarks()

##----------------------------------------------------------------------
##-- menu signals ------------------------------------------------------

    def menu_open_cb(self, a, w):

        dialog = OpenFileDialog(self)
        if dialog.filename:
            self.insert_file(dialog.filename, 1)

##----------------------------------------------------------------------

    def menu_bookmarks_manager_cb(self, a, w):

        if not self.bookmarks_manager:
            self.bookmarks_manager = BookmarksWindow(self.bookmarks)

            self.bookmarks_manager.connect('destroy',
                                          self.bookmarks_manager_destroy_cb)
            self.bookmarks_manager.connect('load-file',
                                          self.bookmarks_manager_load_file_cb)
            self.bookmarks_manager.connect('book-removed',
                                          self.bookmarks_manager_book_removed_cb)
            self.bookmarks_manager.connect('book-changed',
                                          self.bookmarks_manager_book_changed_cb)
            self.bookmarks_manager.connect('bookmarks-changed',
                                          self.bookmarks_manager_bookmarks_changed_cb)
            self.bookmarks_manager.connect('bookslist-changed', lambda w:
                                          self.update_books_menu())

            width = self.main_properties['bookmarks_manager_width'][1]
            height = self.main_properties['bookmarks_manager_height'][1]
            self.bookmarks_manager.set_default_size(width, height)
            pos = self.main_properties['bookmarks_manager_paned_position'][1]
            self.bookmarks_manager.paned.set_position(pos)
            self.bookmarks_manager.show_all()

        else:
            self.bookmarks_manager.present()

##----------------------------------------------------------------------

    def menu_goto_position_cb(self, a, w):

        strng = entry_dialog(self, 'Position', 'Position(%): ')
        if strng:
            try:
                num = float(strng)
            except:
                pass
            else:
                if num >= 0 and num <= 100:
                    self.text_widget.set_position(num/100.0)

##----------------------------------------------------------------------

    # FONT
    def menu_font_cb(self, a, w):

        dialog = gtk.FontSelectionDialog("%s: Select font" % program_name)
        fontname = self.text_widget.get_style().font_desc.to_string()
        dialog.set_font_name(fontname)
        dialog.set_transient_for(self)
        dialog.show()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:
            font = dialog.get_font_name()
            fd = pango.FontDescription(font)
            self.text_widget.modify_font(fd)

        dialog.destroy()

##----------------------------------------------------------------------

    # COLOR
    def menu_color_cb(self, a, w):

        dialog = gtk.ColorSelectionDialog("%s: Color Select" % program_name)
        dialog.set_transient_for(self)
        dialog.colorsel.set_has_palette(TRUE)
        dialog.show()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:

            color = dialog.colorsel.get_current_color()
            if a == 0:  # foreground
                fg_color = '#%02x%02x%02x' \
                           % (color.red>>8,
                              color.green>>8,
                              color.blue>>8)
                self.text_widget.modify_text(gtk.STATE_NORMAL, color) # text fg
                self.main_properties['fg_color'][1] = fg_color
            elif a == 1: # background
                bg_color = '#%02x%02x%02x' \
                           % (color.red>>8,
                              color.green>>8,
                              color.blue>>8)
                self.text_widget.modify_base(gtk.STATE_NORMAL, color) # text bg
                self.main_properties['bg_color'][1] = bg_color
            else:        # highlight
                tag_color = '#%02x%02x%02x' \
                            % (color.red>>8,
                               color.green>>8,
                               color.blue>>8)
                self.main_properties['bookmark_tag_color'][1] = tag_color
                self.text_buffer.change_bookmark_tag_color(tag_color)


        dialog.destroy()

##----------------------------------------------------------------------

    def menu_props_cb(self, a, w):

        dialog = PropsWindow(self)
        response = dialog.run()

        if response == gtk.RESPONSE_OK:

            if len(dialog.scroll_properties) != 0:
                for i in dialog.scroll_properties:
                    self.text_widget.scroll_properties[i][0] \
                        = dialog.scroll_properties[i]

            if len(dialog.scroll_type) != 0:
                for i in dialog.scroll_type:
                    self.text_widget.scroll_type[i][0] \
                         = dialog.scroll_type[i]

            if len(dialog.text_properties) != 0:
                for i in dialog.text_properties:
                    self.text_widget.text_properties[i][0] \
                         = dialog.text_properties[i]

                self.text_widget.set_properties()

        dialog.destroy()

##----------------------------------------------------------------------

    def menu_set_bookmark_cb(self, a, w):

        rect = self.text_widget.get_visible_rect()
        iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
        offset = iter.get_offset()

        desc = self.text_buffer.mark_description(offset)

        self.current_book.add_bookmark(self.text_widget.get_position(),
                                       offset, desc)
        self.text_buffer.highlight_bookmark(offset)
        if self.bookmarks_manager:
            self.bookmarks_manager.update_treeview()

        self.update_bookmarks_menu()

##----------------------------------------------------------------------

    def menu_set_bookmark_with_cb(self, a, w):

        desc = entry_dialog(self, 'Description', 'Description: ')
        if desc != None:
            rect = self.text_widget.get_visible_rect()
            iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
            offset = iter.get_offset()
            self.current_book.add_bookmark(self.text_widget.get_position(),
                                           offset, desc)
            self.text_buffer.highlight_bookmark(offset)
            if self.bookmarks_manager:
                self.bookmarks_manager.update_treeview()

        self.update_bookmarks_menu()

##----------------------------------------------------------------------

    def menu_speed_cb(self, a, w):
        if a == 0  : # fast
            adj = self.scale.get_adjustment()
            adj.set_value(adj.value + adj.step_increment)
        elif a == 1: # slow
            adj = self.scale.get_adjustment()
            adj.set_value(adj.value - adj.step_increment)
        elif a == 2: # pause
            self.pause_toggle.set_active(not self.pause_toggle.get_active())

##----------------------------------------------------------------------

    def menu_charset_cb(self, a, w):
        # FIXME: change description?

        if not self.current_book: return
        if self.current_book.encoding == charsets_list[a]: return
        if self.block_change_charset: return

        self.current_book.encoding = charsets_list[a]
        self.insert_file(self.current_book.filename)

##----------------------------------------------------------------------
##----------------------------------------------------------------------

    def pause_toggled_cb(self, w):
        self.text_widget.pause_toggled(w.get_active())

##----------------------------------------------------------------------

    def create_statusbar(self):

        statusbar_hbox = gtk.HBox()

        label_speed = gtk.Label('Speed: ')
        statusbar_hbox.pack_start(label_speed, expand=FALSE, padding=4)

        scale = gtk.HScale()
        scale.set_size_request(200, -1)
        scale.set_range(1, 100)
        scale.set_increments(1, 1)
        scale.set_value(self.text_widget.speed)
        scale.set_property('draw_value', FALSE)
        scale.set_property('can_focus', FALSE)
        scale.connect('value_changed', self.speed_changed_cb)
        self.scale = scale

        statusbar_hbox.pack_start(scale, expand=TRUE, padding=4)

        toggle = gtk.ToggleButton()
        self.pause_toggle = toggle
        toggle.set_active(TRUE)
        toggle.set_label('Pause')
        toggle.set_property('can_focus', FALSE)
        toggle.set_property('border_width', 4)
        toggle.connect('toggled', self.pause_toggled_cb)
        toggle.set_accel_path('<main>/Speed/Pause', self.accelgroup)

        statusbar_hbox.pack_start(toggle, expand=FALSE)

        self.statusbar_1 = gtk.Label('')
        statusbar_hbox.pack_start(self.statusbar_1, expand=TRUE)

        self.percent_status = gtk.Label('0%')
        statusbar_hbox.pack_start(self.percent_status, fill=TRUE, expand=FALSE)

        self.percent_status.modify_font(pango.FontDescription(self.percent_font))

        grid = gtk.Statusbar()
        statusbar_hbox.pack_start(grid, expand=FALSE)
        grid.set_size_request(24, 24)

        self.statusbar = statusbar_hbox

        return statusbar_hbox

##----------------------------------------------------------------------

    def insert_file(self, filename, update_treeview=0):
        # --- check file ---

        if not os.path.isfile(filename):
            raise OpenFileError, 'is not an existing regular file'

        try:
            fd =  open(filename)
        except IOError, err:
            raise OpenFileError, err
        else:
            fd.close()

        book = self.bookmarks.get_book(filename)
        if book:
            found = 1
        else:
            found = 0

        if self.current_book:
            self.save_bookmark()

        if found:
            self.text_buffer.set_book(book)
        else:
            self.text_buffer.new_book(filename)

        self.text_buffer.load_file()

        self.current_book = self.text_buffer.book

        # set title
        title = self.current_book.get_title()
        self.set_title('%s: %s' % (program_name, title))

        if not found:
            self.bookmarks.add_new_book(self.current_book)

        self.main_properties['filename'][1] = filename #???

        if self.bookmarks_manager and update_treeview:
            self.bookmarks_manager.update_treeview()

        # set charset menu
        self.block_change_charset = 1
        menu_item = self.item_factory.get_item('/Charset/' \
                                               + self.current_book.encoding)
        menu_item.set_active(TRUE)
        self.block_change_charset = 0

        # set position
        if found:
            # FIXME: how???
            gtk.idle_add(self.set_position)
            #gtk.timeout_add(1000, self.set_position)
            #self.set_position()

        self.update_bookmarks_menu()
        self.update_books_menu()

##----------------------------------------------------------------------

    def set_position(self):
        iter = self.text_buffer.get_iter_at_offset(self.current_book.current_offset)
        self.text_widget.scroll_to_iter(iter, 0.0, TRUE, 0.0, 0.0)

##----------------------------------------------------------------------
    def update_bookmarks_menu(self):

        # make bookmarks menu
        self.bookmarks_submenu = gtk.Menu()

        if self.current_book:
            for i in range(len(self.current_book.marks_list)):
                s = self.current_book.marks_list[i].description
                menuitem = gtk.MenuItem(fix_description(s, 50)) # FIXME: length
                menuitem.connect('activate', self.menu_activate_bookmark_cb,
                                 self.current_book.marks_list[i].number)
                self.bookmarks_submenu.add(menuitem)
                menuitem.show()

        self.bookmarks_menu.set_submenu( self.bookmarks_submenu)

##----------------------------------------------------------------------

    def menu_activate_bookmark_cb(self, w, n):

        m = self.bookmarks.get_mark(self.current_book, n)
        if m:
            self.current_book.current_position = m.position
            self.current_book.current_offset = m.offset
            self.set_position()

##----------------------------------------------------------------------

    def update_books_menu(self):

        self.books_submenu = gtk.Menu()

        for c in self.bookmarks.categories_list:
            for b in self.bookmarks.categories_list[c]:

                name = b.get_title()

                menuitem = gtk.MenuItem(name)
                menuitem.connect('activate', self.menu_activate_book_cb,
                                 b.filename)
                self.books_submenu.add(menuitem)
                menuitem.show()

        self.books_menu.set_submenu( self.books_submenu)

##----------------------------------------------------------------------

    def menu_activate_book_cb(self, w, filename):
        if self.main_properties['filename'][1] != filename:
            self.insert_file(filename)

##----------------------------------------------------------------------

    def save_bookmark(self):

        #if not self.main_properties['filename'][1]: return
        if not self.current_book: return

        self.current_book.current_position = self.text_widget.get_position()

        rect = self.text_widget.get_visible_rect()
        iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
        offset = iter.get_offset()
        self.current_book.current_offset = offset


##----------------------------------------------------------------------

    def make_config_dir(self):
        if os.path.exists(config_dir) and os.path.isdir(config_dir):
            return 1
        else:
            try:
                os.mkdir(config_dir)
            except Exception, err:
                print "ERROR: can't make config dir:", err
                return 0
            return 1

##----------------------------------------------------------------------

    def save_config(self):

        self.main_properties['font'][1] \
            = self.text_widget.get_style().font_desc.to_string()

        self.main_properties['speed'][1] = self.text_widget.speed
        self.main_properties['file_select_path'][1] \
            = OpenFileDialog.file_select_path

        try:
            fd = open(config_file, 'w')
        except:
            print "WARNING: can't open configuration file:", config_file
            return

        fd.write('[pybookreader]\n')

        for i in self.main_properties:
            if i == 'filename' and self.main_properties[i][1] == None:
                # FIXME: this is hack: if filename == None
                pass
            else:
                fd.write('%s=%s\n' % (i, self.main_properties[i][1]))

        for i in self.text_widget.scroll_properties:
            fd.write('%s=%s\n' % (i, self.text_widget.scroll_properties[i][0]))

        for i in self.text_widget.scroll_type:
            fd.write('%s=%s\n' % (i, self.text_widget.scroll_type[i][0]))

        for i in self.text_widget.text_properties:
            fd.write('%s=%s\n' % (i, self.text_widget.text_properties[i][0]))


        fd.write('\n')

        fd.close()


##----------------------------------------------------------------------

    def read_config(self):

        try:
            fd = open(config_file)
        except:
            return

        properties = {}
        flag = 0

        for line in fd.readlines():
            if line == '[pybookreader]\n':
                flag = 1
                continue
            elif line[0] == '[':
                flag = 0
            elif flag == 1:
                indx = string.find(line, '=')
                if indx == -1:
                    continue
                properties[line[0:indx]] = line[indx+1:len(line)-1]


        for i in self.main_properties:
            if properties.has_key(i):
                if self.main_properties[i][0] == 'int':
                    self.main_properties[i][1] = int(properties[i])
                elif self.main_properties[i][0] == 'float':
                    self.main_properties[i][1] = float(properties[i])
                else:
                    self.main_properties[i][1] = properties[i]


        font = pango.FontDescription(self.main_properties['font'][1])
        self.text_widget.modify_font(font)

        color = gtk.gdk.color_parse(self.main_properties['fg_color'][1])
        self.text_widget.modify_text(gtk.STATE_NORMAL, color)

        color = gtk.gdk.color_parse(self.main_properties['bg_color'][1])
        self.text_widget.modify_base(gtk.STATE_NORMAL, color)

        self.text_buffer.change_bookmark_tag_color(self.main_properties['bookmark_tag_color'][1])

        self.text_widget.speed = self.main_properties['speed'][1]
        self.text_widget.speed_changed()

        OpenFileDialog.file_select_path = self.main_properties['file_select_path'][1]

        for i in self.text_widget.text_properties:
            if properties.has_key(i):
                self.text_widget.text_properties[i][0] = int(properties[i])

        for i in self.text_widget.scroll_properties:
            if properties.has_key(i):
                self.text_widget.scroll_properties[i][0] = int(properties[i])

        for i in self.text_widget.scroll_type:
            if properties.has_key(i):
                self.text_widget.scroll_type[i][0] = int(properties[i])

        self.text_widget.set_properties()


##----------------------------------------------------------------------
##----------------------------------------------------------------------

if(__name__=="__main__"):

    br = PyBookReader()
    gtk.main()

