#!/usr/bin/env python
# -*- mode: python; coding: koi8-r -*-


import gtk
from gtk import TRUE, FALSE


##----------------------------------------------------------------------
##----------------------------------------------------------------------


class PropsWindow(gtk.Dialog):


    def __init__(self, parent):

        gtk.Dialog.__init__(self, 'dialog', parent,
                            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                            (gtk.STOCK_OK, gtk.RESPONSE_OK,
                             gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))

        notebook = gtk.Notebook()
        self.vbox.pack_start(notebook, expand=TRUE, fill=TRUE)

        table = gtk.Table(len(parent.text_widget.scroll_properties), 2)
        table.set_row_spacings(4)
        table.set_col_spacings(4)

        vbox = gtk.VBox()
        vbox.pack_start(table, expand=FALSE, fill=FALSE)

        label = gtk.Label('')
        label.set_text_with_mnemonic('_Scrolling')
        notebook.append_page(vbox, label)

        for i in parent.text_widget.scroll_properties:

            n = parent.text_widget.scroll_properties[i][2]
            label = gtk.Label(parent.text_widget.scroll_properties[i][1])
            label.set_use_underline(TRUE)
            table.attach_defaults(label, 0, 1, n, n+1)
            spin = gtk.SpinButton()
            spin.set_range(parent.text_widget.scroll_properties[i][3],
                           parent.text_widget.scroll_properties[i][4])
            spin.set_increments(1, 4)
            spin.set_value(parent.text_widget.scroll_properties[i][0])
            spin.connect('value_changed', self.spin_value_changed_2, i)
            table.attach_defaults(spin, 1, 2, n, n+1)
            label.set_mnemonic_widget(spin)

        for i in parent.text_widget.scroll_type:
            n = parent.text_widget.scroll_type[i][2]
            check = gtk.CheckButton(parent.text_widget.scroll_type[i][1])
            check.set_active(parent.text_widget.scroll_type[i][0])
            check.connect('toggled', self.check_toggled, i)
            table.attach_defaults(check, 0, 2, n+3, n+4)

        table = gtk.Table(len(parent.text_widget.text_properties), 2)
        table.set_row_spacings(4)
        table.set_col_spacings(4)

        vbox = gtk.VBox()
        vbox.pack_start(table, expand=FALSE, fill=FALSE)

        label = gtk.Label('')
        label.set_text_with_mnemonic('_Text')
        notebook.append_page(vbox, label)

        for i in parent.text_widget.text_properties:
            n = parent.text_widget.text_properties[i][2]
            label = gtk.Label(parent.text_widget.text_properties[i][1])
            label.set_use_underline(TRUE)
            label.set_justify(gtk.JUSTIFY_LEFT)
            table.attach_defaults(label, 0, 1, n, n+1)
            spin = gtk.SpinButton()
            spin.set_range(parent.text_widget.text_properties[i][3],
                           parent.text_widget.text_properties[i][4])
            spin.set_increments(1, 4)
            spin.set_value(parent.text_widget.text_properties[i][0])
            spin.connect('value_changed', self.spin_value_changed, i)
            table.attach_defaults(spin, 1, 2, n, n+1)
            label.set_mnemonic_widget(spin)

        self.scroll_properties = {}
        self.scroll_type = {}
        self.text_properties = {}

        self.show_all()

##----------------------------------------------------------------------

    def check_toggled(self, w, name):
        self.scroll_type[name] = w.get_active()

##----------------------------------------------------------------------

    def spin_value_changed(self, w, name):
        self.text_properties[name] = w.get_value_as_int()

##----------------------------------------------------------------------

    def spin_value_changed_2(self, w, name):
        self.scroll_properties[name] = w.get_value_as_int()

##----------------------------------------------------------------------
##----------------------------------------------------------------------
